10 ' Microsoft Basic Program to show a CALL to Elapsed time from The Z80 Simulator.
20 ' When calling TSTOP% need to pass a string so MBETime can fill it with the elasped time.
30 ' Modified original TBS Benchmark Tester to demonstrate capturing elapsed time in CMM2 Z80 Simulator 
40 PRINT "CMM2 CP/M MBASIC Timing Tests Using CALL"
50 GOSUB 880 ' load assembly program
60 PRINT " "
80 TSTART% = &HD000
90 TSTOP% = &HD005
100 J0 = 0
110 A = 0
120 PRINT "Test 1 = ";
130 CALL TSTART% ' start timer
140 FOR J = 1 TO 1000
150 NEXT J
160 CALL TSTOP%(S$) ' end timer and create a string
170 PRINT VAL(S$)/1E+06
180 J0 = 0
190 PRINT "Test 2 = ";
200 CALL TSTART% ' start timer
210 J =J0
220 J = J+1
230 IF J < 1000 THEN GOTO 220
240 CALL TSTOP% (S$) ' end timer and create a string
250 PRINT VAL(S$)/1E+06
260 PRINT "Test 3 = ";
270 CALL TSTART% ' start timer
280 J = 0
290 J = J+1
300 A = J/J*J+J-J
310 IF J < 1000 THEN GOTO 290
320 CALL TSTOP% (S$) ' end timer and create a string
330 PRINT VAL(S$)/1E+06
340 PRINT "Test 4 = ";
350 CALL TSTART% ' start timer
360 J = 0
370 J = J+1
380 A = J/2*3+4-5
390 IF J < 1000 THEN GOTO 370
400 CALL TSTOP% (S$) ' end timer and create a string
410 PRINT VAL(S$)/1E+06
420 PRINT "Test 5 = ";
430 CALL TSTART% ' start timer
440 J = 0
450 J = J+1
460 M = J/2*3+4-5
470 GOSUB 980
480 IF J < 1000 THEN GOTO 450
490 CALL TSTOP% (S$) ' end timer and create a string
500 PRINT VAL(S$)/1E+06
510 PRINT "Test 6 = ";
520 CALL TSTART% ' start timer
530 J = 0
540 DIM RAY(5)
550 J = J+1
560 M = J/2*3+4-5
570 GOSUB 980
580 FOR Q = 1 TO 5
590 NEXT Q
600 IF J < 1000 THEN GOTO 550
610 CALL TSTOP% (S$) ' end timer and create a string
620 PRINT VAL(S$)/1E+06
630 PRINT "Test 7 = ";
640 CALL TSTART% ' start timer
650 J = 0
660 DIM RAY2(5)
670 J = J+1
680 M = J/2*3+4-5
690 GOSUB 980
700 FOR Q = 1 TO 5
710 RAY2(Q) = M
720 NEXT Q
730 IF J < 1000 THEN GOTO 670
740 CALL TSTOP% (S$) ' end timer and create a string
750 PRINT VAL(S$)/1E+06
760 PRINT "Test 8 = ";
770 CALL TSTART% ' start timer
780 J = 0
790 J = J+1
800 M = J^2
810 BLOG = LOG(J)
820 CSIN = SIN(J)
830 IF J < 1000 THEN GOTO 790
840 CALL TSTOP% (S$) ' end timer and create a string
850 PRINT VAL(S$)/1E+06
860 END
870 ' ROUTINE TO LOAD THE ASSEMBLY PROGRAM
880 ASSADDRESS% = &HD000
890 READ NBYTE%
900 IF NBYTE% = 9999 THEN RETURN
910 POKE ASSADDRESS%,NBYTE%
920 ASSADDRESS% = ASSADDRESS% +1
930 GOTO 890 ' LOOP
940 ' THE ASSEMBLY PROGRAM TAKEN FROM THE HEX FILE
950 DATA  &H3E,&H92,&HDD,&H00,&HC9,&HE5,&H3E,&H93,&HDD,&H00,&H23,&H5E,&H23,&H56,&H21,&H4B
960 DATA  &H00,&H06,&H0A,&H0E,&H00,&H3E,&H09,&HDD,&H00,&H0E,&H00,&HEB,&H7E,&HFE,&H00,&HCA
970 DATA  &H2D,&HD0,&H23,&H0C,&H3E,&H28,&HB9,&HCA,&H2D,&HD0,&HC3,&H1C,&HD0,&HE1,&H71,&HC9,9999
980 RETURN

